/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.relatorios;

import java.sql.SQLException;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.sql.DataSource;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.InputEvent;
import org.zkoss.zul.Button;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.ComboitemRenderer;
import org.zkoss.zul.Datebox;

import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioAproveitamento;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.service.CorridaService;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxParada;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxParadaCve;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCorridaAproveitamento;

/**
 * 
 * @author Administrador
 */
@Controller("relatorioAproveitamentoController")
@Scope("prototype")
public class RelatorioAproveitamentoController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(RelatorioAproveitamentoController.class);

	@Autowired
	private CorridaService corridaService;

	private Datebox fecCorrida;
	private MyTextbox txtCorridaId;

	private MyComboboxParada cmbParadaOrigem;
	private MyComboboxParadaCve cmbParadaOrigemCve;
	private MyComboboxParada cmbParadaDestino;
	private MyComboboxParadaCve cmbParadaDestinoCve;
	private Button btnExecutarRelatorio;
	private MyListbox corridaList;

	@Autowired
	private DataSource dataSourceRead;

	@Autowired
	private transient PagedListWrapper<Corrida> plwCorrida;

	public Datebox getFecCorrida() {
		return fecCorrida;
	}

	public void setFecCorrida(Datebox fecCorrida) {
		this.fecCorrida = fecCorrida;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		corridaList.setItemRenderer(new RenderCorridaAproveitamento());

		corridaList.addEventListener("onDoubleClick", new EventListener() {
			@Override
			public void onEvent(Event event) throws Exception {
				txtCorridaId.setValue(((Corrida) corridaList.getSelected()).getId().getCorridaId().toString());
				executarRelatorio();
			}
		});

		btnExecutarRelatorio.setDisabled(true);

		cmbParadaOrigemCve.setItemRenderer(new ComboitemRenderer() {

			@Override
			public void render(Comboitem cmbtm, Object o) throws Exception {
				Parada parada = (Parada) o;

				cmbtm.setLabel(parada.getCveparada());
				cmbtm.setValue(parada);

			}
		});

		cmbParadaDestinoCve.setItemRenderer(new ComboitemRenderer() {

			@Override
			public void render(Comboitem cmbtm, Object o) throws Exception {
				Parada parada = (Parada) o;

				cmbtm.setLabel(parada.getCveparada());
				cmbtm.setValue(parada);

			}
		});

	}

	public void onClick$btnBuscarServico(Event ev) throws Exception {
		refreshLista();
	}

	public void onClick$btnExecutarRelatorio(Event ev) throws Exception {
		executarRelatorio();
	}

	public void onSelect$cmbParadaOrigemCve(Event ev) {
		if (cmbParadaOrigemCve.getSelectedItem() != null) {
			cmbParadaOrigem.setComboItemByParada((Parada) cmbParadaOrigemCve.getSelectedItem().getValue());
		}

	}

	public void onSelect$cmbParadaOrigem(Event ev) {

		if (cmbParadaOrigem.getSelectedItem() != null)
			cmbParadaOrigemCve.setComboItemByParada((Parada) cmbParadaOrigem.getSelectedItem().getValue());

	}

	public void onSelect$cmbParadaDestinoCve(Event ev) {

		if (cmbParadaDestinoCve.getSelectedItem() != null)
			cmbParadaDestino.setComboItemByParada((Parada) cmbParadaDestinoCve.getSelectedItem().getValue());

	}

	public void onSelect$cmbParadaDestino(Event ev) {

		if (cmbParadaDestino.getSelectedItem() != null)
			cmbParadaDestinoCve.setComboItemByParada((Parada) cmbParadaDestino.getSelectedItem().getValue());

	}

	public void onSelect$corridaList(Event ev) {
		txtCorridaId.setValue(((Corrida) corridaList.getSelected()).getId().getCorridaId().toString());
		btnExecutarRelatorio.setDisabled(false);

	}

	public void onChanging$txtCorridaId(InputEvent ev) {

		if (ev.getValue().equals(""))
			btnExecutarRelatorio.setDisabled(true);
		else
			btnExecutarRelatorio.setDisabled(false);
	}

	private void refreshLista() {
		btnExecutarRelatorio.setDisabled(true);

		Parada origem = null;
		Comboitem cbiOrigem = cmbParadaOrigem.getSelectedItem();
		if (cbiOrigem != null) {
			origem = (Parada) cbiOrigem.getValue();
		}

		Parada destino = null;
		Comboitem cbiDestino = cmbParadaDestino.getSelectedItem();
		if (cbiDestino != null) {
			destino = (Parada) cbiDestino.getValue();
		}

		Date data = null;
		if (fecCorrida.getValue() != null) {
			data = fecCorrida.getValue();
			data.setHours(00);
			data.setMinutes(00);
			data.setSeconds(00);
		}

		Integer corridaId = null;
		if (txtCorridaId.getValue() != null && !txtCorridaId.getValue().isEmpty()) {
			corridaId = new Integer(txtCorridaId.getValue());
		}

		List<Corrida> ls = null;
		try {
			ls = corridaService.buscarCorridaRelatorio(dataSourceRead.getConnection(),
					origem, destino, data, corridaId);
		} catch (SQLException e) {
			log.error("", e);
		}

		corridaList.setData(ls);

		if (corridaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("relatorioAproveitamentoController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
				log.error("", ex);
			}
		}

		if (corridaList.getData().length == 1) {
			corridaList.setSelectedIndex(0);
			btnExecutarRelatorio.setDisabled(false);
		}

	}

	/**
	 * @throws Exception
	 * 
	 */
	private void executarRelatorio() throws Exception {

		Map<String, Object> parametros = new HashMap<String, Object>();

		parametros.put("CORRIDA_ID", this.txtCorridaId.getValue());
		parametros.put("FECCORRIDA", new java.sql.Date(((java.util.Date) this.fecCorrida.getValue()).getTime()));
		parametros.put("DATA", DateUtil.getStringDate((java.util.Date) this.fecCorrida.getValue())); // Utilizada para exibição no cabeçalho
		parametros.put("NOME_RELATORIO", Labels.getLabel("relatorioAproveitamentoController.window.title"));

		Relatorio relatorio = new RelatorioAproveitamento(parametros, dataSourceRead.getConnection());
		Map args = new HashMap();
		args.put("relatorio", relatorio);

		openWindow("/component/reportView.zul",
				Labels.getLabel("relatorioAproveitamentoController.window.title"), args, MODAL);

	}

}
